VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4272
   ClientLeft      =   60
   ClientTop       =   456
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4272
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox OutputText 
      Height          =   2892
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   840
      Width           =   4335
   End
   Begin VB.CommandButton StartButton 
      Caption         =   "Start"
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/****************************************************************************
'    Copyright  2005 Agilent Technologies Inc. All rights
'    reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Agilent has no
' warranty,  obligations or liability for any Sample Application Files.
'
' Agilent Technologies provides programming examples for illustration only,
' This sample program assumes that you are familiar with the programming
' language being demonstrated and the tools used to create and debug
' procedures. Agilent support engineers can help explain the
' functionality of Agilent software components and associated
' commands, but they will not modify these samples to provide added
' functionality or construct procedures to meet your specific needs.
'****************************************************************************/

' This example shows how to do waveform capture with the 34410A/11A by setting a high sample rate.
' The use of the "peak detect" capability is also illustrated in this program.
' Peak detect registers are cleared for each Initiate of single or multiple samples per trigger.
' Configuration:
'  34410A or 34411A Digital Multimeter
'  DCV Power supply with ACV ripple connect to input terminals

Private Sub StartButton_Click()

    On Error GoTo ReportError
    
    OutputText.Text = ""
    
    Dim standardInitOptions As String

    Dim driver34410 As IAgilent34410
    
    Set driver34410 = New Agilent34410Lib.Agilent34410

    ' Setup IVI-defined initialization options
    standardInitOptions = "Cache=true, InterchangeCheck=false, QueryInstrStatus=false, RangeCheck=true, RecordCoercions=false, Simulate=false"

    ' Initialize the driver
    driver34410.Initialize "TCPIP0::156.140.71.39::INSTR", False, False, standardInitOptions
     
    ' Configure the 34410A/11A for voltage measurement, using 10 V range
    driver34410.Voltage.DCVoltage.Configure 10, Agilent34410ResolutionEnum.Agilent34410ResolutionDefault
    driver34410.Voltage.DCVoltage.AutoZero = Agilent34410AutoZeroOnce

    ' Set aperture to 100usec (34411A can be set to 20usec)
    driver34410.Voltage.DCVoltage.Aperture = 0.0001

    ' Set up triggering for 1000 samples from a single trigger event
    driver34410.Trigger.TriggerSource = Agilent34410TriggerSourceEnum.Agilent34410TriggerSourceImmediate
    driver34410.Trigger.TriggerCount = 1
    driver34410.Trigger.TriggerDelay = 0
    driver34410.Trigger.SampleCount = 1000
    driver34410.Trigger.SampleInterval = 0.0001
    driver34410.Trigger.SampleSource = Agilent34410SampleSourceEnum.Agilent34410SampleSourceTimer

    ' Set up data format for binary transfer 64-bit transfer
    driver34410.DataFormat.DataFormat = Agilent34410DataFormatEnum.Agilent34410DataFormatReal64

    ' Initiate the measurement
    driver34410.Measurement.Initiate

    ' We will now read the results.  The method below illustrates how to read data out of the
    ' 34410 as it becomes available.  This is more useful when taking large amounts of data or perhaps
    ' when doing a "continuous" measurement.  With this method, the application does not need to wait
    ' until all the data is taken to begin accessing (and possibly processing) some of the data. Instead
    ' a "block" of data is accumulated and then read out and processed in some way before getting the
    ' next "block".

    ' Get 1000 readings in "blocks" of 100
    Dim dataPts As Integer
    Dim data() As Double
    Dim i As Integer
    Dim globalCount As Integer
    
    globalCount = 0
    For i = 0 To 9
        dataPts = 0
        While dataPts < 100
            dataPts = driver34410.Measurement.ReadingCount(Agilent34410MemoryTypeEnum.Agilent34410MemoryTypeReadingMemory)
        Wend

        ' We have 100 data points, lets read them out
        Dim tempData() As Double
        tempData = driver34410.Measurement.RemoveReadings(100)
        
        ' Add them to the "collection" array
        ' At this point you could also "process" the data in some way while waiting for the next
        ' "block" of measurements to be acquired by the instrument.
        Dim count As Integer
        count = UBound(tempData) - LBound(tempData) + 1
        ReDim Preserve data(0 To globalCount + count - 1) As Double
        Dim j As Integer
        For j = 0 To count - 1
            data(globalCount + j) = tempData(j)
        Next
        globalCount = UBound(data) - LBound(data) + 1
    Next

    OutputText.Text = OutputText.Text & "Read out: " & Str(UBound(data) - LBound(data)) & " readings" & vbCr & vbLf

    ' Print first and last reading values
    OutputText.Text = OutputText.Text & "First reading of 1000 taken was: " & Str(data(0)) & " V" & vbCr & vbLf
    OutputText.Text = OutputText.Text & "Last reading of 1000 taken was: " & Str(data(999)) & " V" & vbCr & vbLf

    ' Measure DCV that has AC ripple
    ' Show using Peak Detect to capture peaks of ripple
    ' Make ACV and Frequency measurements of same signal
    ' Using Peak Detect essentially gives you an AC + DC measurement

    ' Configure the 34410 for a single reading, 10 Volt range
    driver34410.Voltage.DCVoltage.Configure 10, Agilent34410ResolutionEnum.Agilent34410ResolutionDefault

    ' Set 10 Power Line Cycles of integration time on the measurement
    driver34410.Voltage.DCVoltage.NPLC = 10#

    ' Enable peak detection to capture any "noise" on the measurement
    driver34410.Voltage.DCVoltage.PeakState = True

    ' Initiate the measurement
    driver34410.Measurement.Initiate

    ' Allow a 2 second timeout when before trying to fetch
    'driver34410.System.WaitForOperationComplete(1100)
    driver34410.System.TimeoutMilliseconds = 2000

    ' Read the results -- only a single reading
    Dim data2() As Double
    data2 = driver34410.Measurement.Fetch()

    OutputText.Text = OutputText.Text & vbCr & vbLf & "10 PLC reading was: " & Str(data2(0)) & " V" & vbCr & vbLf

    Dim maxPeak As Double
    Dim minPeak As Double
    Dim pkToPk As Double

    maxPeak = driver34410.Voltage.DCVoltage.maxPeak
    minPeak = driver34410.Voltage.DCVoltage.minPeak
    pkToPk = driver34410.Voltage.DCVoltage.PeakToPeak
    
    OutputText.Text = OutputText.Text & "maxPeak = " & Str(maxPeak) & " V; minPeak = " & Str(minPeak) & " V; pkToPk = " & Str(pkToPk) & " V" & vbCr & vbLf

    ' Measurement the AC RMS value of the ripple voltage
    Dim voltsAC As Double
    voltsAC = driver34410.Voltage.ACVoltage.Measure(-1, Agilent34410ResolutionEnum.Agilent34410ResolutionDefault)
    OutputText.Text = OutputText.Text & vbCr & vbLf & "An AC Volts measurement returned: " & Str(voltsAC) & " VAC" & vbCr & vbLf

    ' Measure frequency of the ripple voltage
    Dim freq As Double
    freq = driver34410.Frequency.Measure(-1, Agilent34410ResolutionEnum.Agilent34410ResolutionDefault)
    OutputText.Text = OutputText.Text & vbCr & vbLf & "Frequency measurement returned: " & Str(freq) & " Hz" & vbCr & vbLf

    ' Close driver
    driver34410.Close
    
    Exit Sub
    
ReportError:
    OutputText.Text = OutputText.Text & Err.Description & vbCr & vbLf

End Sub
